export declare const schema = "\"\"\"\nJavaScript Date stored as a Number in DynamoDB\n\"\"\"\nscalar Date\n\n\"\"\"\nArbitrary JSON stored as a Map in DynamoDB\n\"\"\"\nscalar JSONObject\n\n\"\"\"\nAllows specifying an alternate column name.\n\"\"\"\ndirective @alias(name: String!) on FIELD_DEFINITION\n\n\"\"\"\nIndicates all reads for this type will be done using DynamoDB's\nstrong-consistency mode. General discouraged, though certain user-facing flows\nmight require it.\n\"\"\"\ndirective @consistent on OBJECT\n\n\"\"\"\nIndicates the Model in question must use a partition key without a sort key as\nits primary key.\n\"\"\"\ndirective @partitionKey(pkFields: [String!]!, pkPrefix: String) on OBJECT\n\n\"\"\"\nReusable options for all generated lambdas\n\"\"\"\ninput LambdaConfig {\n  \"\"\"\n  Measured in megabytes.\n  \"\"\"\n  memory: Int\n  \"\"\"\n  Measured in seconds. Reminder that handlers may need to do retries in-band, so\n  consider making this a relatively high number and using alarms to catch\n  timeouts rather than terminating the function. In order to make space for up\n  to 5 retries, please add sixty seconds to your intended timeout.\n  \"\"\"\n  timeout: Int\n}\n\n\"\"\"\nConfiguration specific to a table dispatcher\n\"\"\"\ninput DispatcherConfig {\n  lambdaConfig: LambdaConfig\n}\n\n\"\"\"\nConfiguration specific to a model handler\n\"\"\"\ninput HandlerConfig {\n  lambdaConfig: LambdaConfig\n}\n\n\"\"\"\nCDC Event Types\n\"\"\"\nenum CdcEvent {\n  INSERT\n  MODIFY\n  REMOVE\n  UPSERT\n}\n\n\"\"\"\nEnriches the targetModel anytime there's a change to this model.\n\"\"\"\ndirective @enriches(\n  \"\"\"\n  Optional config to define the lambda parameters for the dispatcher and related\n  resources\n  \"\"\"\n  dispatcherConfig: DispatcherConfig\n  \"\"\"\n  The type of change events to subscribe to.\n  \"\"\"\n  event: CdcEvent!\n  \"\"\"\n  Optional config to define the lambda parameters for the handler and related\n  resources\n  \"\"\"\n  handlerConfig: HandlerConfig\n  \"\"\"\n  Name to import from the module at importPath.\n  \"\"\"\n  importName: String!\n  \"\"\"\n  Path to the requireable package that handles a specific event.\n  \"\"\"\n  importPath: String!\n  \"\"\"\n  The model type that will be updated by this stream.\n  \"\"\"\n  targetModel: String!\n) repeatable on OBJECT\n\n\"\"\"\nTriggers the specified handler whenever there's a change to this model.\n\"\"\"\ndirective @reduces(\n  \"\"\"\n  Optional config to define the lambda parameters for the dispatcher and related\n  resources\n  \"\"\"\n  dispatcherConfig: DispatcherConfig\n  \"\"\"\n  The type of change events to subscribe to.\n  \"\"\"\n  event: CdcEvent!\n  \"\"\"\n  Optional config to define the lambda parameters for the handler and related\n  resources\n  \"\"\"\n  handlerConfig: HandlerConfig\n  \"\"\"\n  Name to import from the module at importPath.\n  \"\"\"\n  importName: String!\n  \"\"\"\n  Path to the requireable package that handles a specific event.\n  \"\"\"\n  importPath: String!\n  \"\"\"\n  Indicates this reducer produces multiple output records\n  \"\"\"\n  multiReduce: Boolean\n  \"\"\"\n  Indicates if this handler's resources should be defined in the main\n  CloudFormation template or in a nested stack\n  \"\"\"\n  nestStack: Boolean\n  \"\"\"\n  List of model names that this handler should be allowed to query. The\n  CloudFormation resource will be updated accordingly.\n  @experimental\n  \"\"\"\n  readableModels: [String!]\n  \"\"\"\n  The model type that will be updated by this stream.\n  \"\"\"\n  targetModel: String!\n  \"\"\"\n  List of model names that this handler should be allowed to write. The\n  CloudFormation resource will be updated accordingly.\n  @experimental\n  \"\"\"\n  writableModels: [String!]\n) repeatable on OBJECT\n\n\"\"\"\nTriggers the specified handler whenever there's a change to this model.\n\"\"\"\ndirective @reacts(\n  \"\"\"\n  Optional config to define the lambda parameters for the dispatcher and related\n  resources\n  \"\"\"\n  dispatcherConfig: DispatcherConfig\n  \"\"\"\n  The type of change events to subscribe to.\n  \"\"\"\n  event: CdcEvent!\n  \"\"\"\n  Optional config to define the lambda parameters for the handler and related\n  resources\n  \"\"\"\n  handlerConfig: HandlerConfig\n  \"\"\"\n  Name to import from the module at importPath.\n  \"\"\"\n  importName: String!\n  \"\"\"\n  Path to the requireable package that handles a specific event.\n  \"\"\"\n  importPath: String!\n  \"\"\"\n  Indicates if this handler's resources should be defined in the main\n  CloudFormation template or in a nested stack\n  \"\"\"\n  nestStack: Boolean\n  \"\"\"\n  List of model names that this handler should be allowed to query. The\n  CloudFormation resource will be updated accordingly.\n  @experimental\n  \"\"\"\n  readableModels: [String!]\n  \"\"\"\n  List of model names that this handler should be allowed to write. The\n  CloudFormation resource will be updated accordingly.\n  @experimental\n  \"\"\"\n  writableModels: [String!]\n) repeatable on OBJECT\n\n\"\"\"\nIndicates this Model has a composite key generated from the specified fields.\n\"\"\"\ndirective @compositeKey(\n  pkFields: [String!]!\n  pkPrefix: String\n  skFields: [String!]!\n  skPrefix: String\n) on OBJECT\n\n\"\"\"\nINCLUDE is omitted at this time because it drastically complicates the schema\nDSL. If a use for it arises, it'll be revisited.\n\"\"\"\nenum ProjectionType {\n  ALL\n  KEYS_ONLY\n}\n\n\"\"\"\nDefines a Global Secondary Index\n\"\"\"\ndirective @gsi(\n  name: String!\n  pkFields: [String!]!\n  pkPrefix: String\n  projectionType: ProjectionType\n  skFields: [String!]\n  skPrefix: String\n) repeatable on OBJECT\n\n\"\"\"\nIndicates that this type is an append-only ledger and should not have touch,\nupdate, or blindWrite.\n\"\"\"\ndirective @ledger on OBJECT\n\n\"\"\"\nDefines a Local Secondary Index\n\"\"\"\ndirective @lsi(\n  name: String!\n  projectionType: ProjectionType\n  skFields: [String!]\n  skPrefix: String\n) repeatable on OBJECT\n\n\"\"\"\nMarks a single field as a Global Secondary Index.\n\"\"\"\ndirective @simpleIndex(projectionType: ProjectionType) on FIELD_DEFINITION\n\n\"\"\"\nPossible case types for converting a fieldName to a DynamoDB column_name.\n\"\"\"\nenum ColumnCase {\n  CAMEL_CASE\n  SNAKE_CASE\n}\n\n\"\"\"\nAllows customizing the generated attributes for a table.\n\"\"\"\ndirective @table(\n  \"\"\"\n  Defaults to ColumnCase.SNAKE_CASE\n  \"\"\"\n  columnCase: ColumnCase\n  \"\"\"\n  Defaults to true\n  \"\"\"\n  enablePointInTimeRecovery: Boolean\n  \"\"\"\n  Defaults to false. If true, enables stream events for the table. Note that\n  you don't need to set this if you're using @enriches or @reacts. This is\n  mostly here for incrementally adopting the library; you can define you schema\n  with graphql and continue emitting stream events and follow up later with\n  targeted cdc directives.\n  \"\"\"\n  enableStreaming: Boolean\n  \"\"\"\n  Allows overriding the generated table name for a Model. Generally, this is not\n  recommended, but you might want to use this if you're migrating an existing\n  set of tables to use this library.\n  Defaults to the PascalCased name of the Model prefixed with Table\n  \"\"\"\n  name: String\n) on OBJECT\n\n\"\"\"\nComputes the value of a field using the specified function.\n\"\"\"\ndirective @computed(\n  importName: String!\n  importPath: String!\n  \"\"\"\n  Virtual computed fields exist for the sole purposes of computing a complex\n  value for use with an index field. The are not persisted to the database on\n  their own.\n\n  Ideally, they would be entirely hidden from the generated types, those types\n  are generated by a third-party plugin. Long run, the solution is probably to\n  write a schema loader that can transform the schema before it's passed to the\n  TypeScript plugin.\n  \"\"\"\n  virtual: Boolean\n) on FIELD_DEFINITION\n\n\"\"\"\nMarks a field as the source for this model's ttl value. May only be declared once per model\n\"\"\"\ndirective @ttl(\n  \"\"\"\n  An ISO 8601 duration string. If no value is specified for the field, the expiration date will be now + this duration\n  \"\"\"\n  duration: String\n  \"\"\"\n  If duration is specified, codegen will not allow user to specify a value for expiration unless this is set to true.\n  \"\"\"\n  overridable: Boolean\n) on FIELD_DEFINITION\n\n\"\"\"\nAllows configuring the ProjectionType for the publicId index of PublicModels\n\"\"\"\ndirective @public(projection: ProjectionType!) on OBJECT\n\n\"\"\"\nModels are DynamoDB tables with a key schema that may or may not include a sort\nkey. A Model must be decorated with either @partitionKey or @compositeKey.\n\nNote that, while Model does not explicitly implement Node, its `id` field\nbehaves like `Node#id` typically does. This is to avoid defining Node in the\ninjected schema if the consumer's schema also defined Node or defines it\ndifferently.\n\"\"\"\ninterface Model implements Timestamped & Versioned {\n  createdAt: Date!\n  id: ID!\n  updatedAt: Date!\n  version: Int!\n}\n\n\"\"\"\nLike Model, but includes a `publicId` field which, unlike `id`, is semantically\nmeaningless. Types implementing PublicModel will have an additional function,\n`queryByPublicId`, generated. If any of your models implement PublicModel, then\nthe dependencies module must include an `idGenerator()`.\n\"\"\"\ninterface PublicModel implements Model & Timestamped & Versioned {\n  createdAt: Date!\n  id: ID!\n  publicId: String!\n  updatedAt: Date!\n  version: Int!\n}\n\n\"\"\"\nAutomatically adds a createdAt and updatedAt timestamp to the entity and sets\nthem appropriately. The createdAt timestamp is only set on create, while the\nupdatedAt timestamp is set on create and update.\n\"\"\"\ninterface Timestamped {\n  \"\"\"\n  Set automatically when the item is first written\n  \"\"\"\n  createdAt: Date!\n  \"\"\"\n  Set automatically when the item is updated\n  \"\"\"\n  updatedAt: Date!\n}\n\n\"\"\"\nAutomatically adds a column to enable optimistic locking. This field shouldn't\nbe manipulated directly, but may need to be passed around by the runtime in\norder to make updates.\n\"\"\"\ninterface Versioned {\n  version: Int!\n}\n";
//# sourceMappingURL=schema.d.ts.map